﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Dynamicweb.Extensibility;
using Dynamicweb.Ecommerce.LiveIntegration.Configuration;
using Dynamicweb.Extensibility.Notifications;
using Dynamicweb.Environment;

namespace Dynamicweb.Ecommerce.LiveIntegration.NotificationSubscribers
{
    [Subscribe(Dynamicweb.Ecommerce.Notifications.Ecommerce.Cart.Line.Removed)]
    public class OrderLineRemoved : NotificationSubscriber
    {
        public override void OnNotify(string notification, NotificationArgs args)
        {
            if (!Configuration.Global.IsIntegrationActive)
                return;

            var myArgs = (Dynamicweb.Ecommerce.Notifications.Ecommerce.Cart.Line.RemovedArgs)args;
            if ((string.IsNullOrEmpty(Helpers.GetConfigValue(Constants.WebServiceConfiguration.Path, Constants.WebServiceConfiguration.Shop)) ||
    Helpers.GetConfigValue(Constants.WebServiceConfiguration.Path, Constants.WebServiceConfiguration.Shop) == (String)Dynamicweb.Frontend.PageView.Current().Area.EcomShopId)
                && UrlHandler.Instance.IsWebServiceUrlFound() && !IsEmptyCartCalled())
            {                
                OrderHandler.UpdateOrder(myArgs.Cart);
            }
        }

        private bool IsEmptyCartCalled()
        {            
            string cartCmd = (Context.Current.Request.GetString("CartCmd")).ToLower();
            return !string.IsNullOrEmpty(cartCmd) && cartCmd == "emptycart";            
        }
    }
}
